ideal
model	tiny
codeseg
	public	_fmput
	public	_fmclear
	public	_fmgset
	public	_fmcset
	public	_fmkey
	public	_fmfrq
; 
proc	_fmput	near
	push	ax cx dx
	mov	dx,388h
	xchg	al,ah
	out	dx,al
	mov	cx,6
	mov	dx,3C0h
@@m1:	in	al,dx
	loop	@@m1
	mov	dx,389h
	xchg	al,ah
	out	dx,al
	mov	cx,35
	mov	dx,3C0h
@@m2:	in	al,dx
	loop	@@m2
	pop	dx cx ax
	ret
endp
; 
proc	_fmclear near
	xor	ax,ax
@@m1:	call	_fmput
	inc	ah
	jnz	@@m1
	ret
endp
; 
; AH= 
; AL=Waveform
; BL=AM,VIB,EG,KSR,MF
; BH=Level key/Total level
; CL=Attack/Decay
; CH=Sustain/Release
proc	_fmgset	near
	and	ah,1Fh
	add	ah,0E0h
	call	_fmput
	add	ah,40h
	mov	al,BL
	call	_fmput
	add	ah,20h
	mov	al,BH
	call	_fmput
	add	ah,20h
	mov	al,CL
	call	_fmput
	add	ah,20h
	mov	al,CH
	call	_fmput
	ret
endp
; 
proc	_fmcset	near
	push	bp
	mov	bp,sp
	push	ds cs
	pop	ds
	cld
	mov	si,[bp+2]
	lodsb
	mov	dl,al
	cmp	al,3
	jb	@@m1
	add	al,5
	cmp	al,11
	jb	@@m1
	add	al,5
@@m1:	and	al,1Fh
	mov	ah,al
	mov	ch,2
@@m3:	mov	cl,4
@@m2:	add	ah,20h
	lodsb
	call	_fmput
	dec	cl
	jnz	@@m2
	add	ah,60h
	lodsb
	call	_fmput
	add	ah,23h
	dec	ch
	jnz	@@m3
	mov	ah,dl
	and	ah,0Fh
	add	ah,0C0h
	lodsb
	call	_fmput
	mov	[bp+2],si
	pop	ds bp
	ret
endp
; 
proc	_fmkey	near
	and	ah,0Fh
	add	ah,0A0h
	mov	al,bl
	call	_fmput
	add	ah,10h
	mov	al,bh
	and	al,3Fh
	jmp	_fmput
endp
; 
proc	_fmfrq	near
	push	ax dx
	mov	dx,34545
	mul	dx
	mov	bx,800h
@@m0:	test	dh,0FCh
	jz	@@m1
	add	bh,4
	shr	dx,1
	jmp	@@m0
@@m1:	or	bx,dx
	pop	dx ax
	ret
endp
; 
end