ideal
P186
model	tiny
codeseg
public	_inidma
;public	_inidma2
; 
; CX = length (bytes/words)
; AH = bit 0: 0 = 8-bit, 1 = 16 bit
; DL:BX = address
; DH = DMA mode Ŀ
;               
;                       DMA channel (0-3)
;                     Transfer mode: 00 = verify
;                                            01 = write
;                                            10 = read 
;                    1 = enable auto-initialize, 0 = disable
;                   Direction: 0 = increment, 1 = decrement
;                 Transfer type: 00 = by demand
;                                                01 = single
;                                                10 = block
;                                                11 = cascade
; 
proc	_inidma
	mov	al,dh
	and	al,3
	or	al,4
	test	ah,1
	jz	@@2
	out	0D4h,al
	mov	al,dh
	out	0D6h,al
	jmp	@@3
;	
@@2:	out	0Ah,al
	mov	al,dh
	out	0Bh,al
@@3:	push	dx bx
	mov	bx,offset dmapg
	mov	al,dh
	and	al,3
	test	ah,1
	jz	@@1
	add	al,4
	and	dl,0FEh
@@1:	mov	ah,al
	segcs
	xlat
	xchg	dl,al
	mov	dh,0
	out	dx,al
	pop	bx dx
	mov	al,ah
	and	al,3
	shl	al,1
	test	ah,4
	jz	@@4
	shl	al,1
	add	al,0C0h
	shr	dl,1
	rcr	bx,1
	mov	dl,al
	mov	dh,0
	out	0D8h,al
	mov	al,bl
	out	dx,al
	mov	al,bh
	out	dx,al
	out	0D8h,al
	inc	dx
	inc	dx
	mov	al,cl
	out	dx,al
	mov	al,ch
	out	dx,al
	mov	al,ah
	and	al,3
	out	0D4h,al
	ret
;	
@@4:	mov	dl,al
	mov	dh,0
	out	0Ch,al
	mov	al,bl
	out	dx,al
	mov	al,bh
	out	dx,al
	out	0Ch,al
	inc	dx
	mov	al,cl
	out	dx,al
	mov	al,ch
	out	dx,al
	mov	al,ah
	and	al,3
	out	0Ah,al
	ret
endp
; 
dmapg	db	87h,83h,81h,82h,8Fh,8Bh,89h,8Ah
end